c-----------------------------------------------------------------------
      subroutine allrea(form, inva, rea, nint, nrea)
c-----------------------------------------------------------------------
c   
c          This subroutine does take the INVA and REA arrays obtained from
c     FREEREAD, converts all integers to real numbers and stores them in
c     the REA array while restoring the same order in which they were in
c     the original line.
c
c     INPUT :  FORM, a string containing the types of the different 
c              substrings found in the LINE by FREEREAD (I, F, or A).
c              INVA, the array containing all the integers
c              REA, the array containing the real numbers
c              NINT and NREA, the number of integers and reals, 
c              respectively.
c
c     OUTPUT : NREA and REA
c
      real rea, oldrea
      integer inva, iint, irea, nint, nrea
c
      character form*(*)
c
      dimension inva(2), rea(2), oldrea(80)
c
      if ((nint .eq. 0) .and. (nrea .eq. 0)) return 
      do i = 1, nrea
           oldrea(i) = rea(i)
      end do
      iint = 0
      nrea = 0
      irea = 0
      call limits(form, is, ie)
      do i = is, ie
           if (form(i:i) .ne. 'A') then
                nrea = nrea + 1
                if (form(i:i) .eq. 'F') then
                     irea = irea + 1
                     rea(nrea) = oldrea(irea)
                else
                     iint = iint + 1
                     rea(nrea) = inva(iint)
                end if
           end if
      end do
      return 
      end
